#import <Cocoa/Cocoa.h>

@class XeeController,XeeDirectoryController;

@interface XeeDelegate:NSObject
{
	NSNib *directorynib,*clipboardnib;
	BOOL filesopened;

	IBOutlet NSMenu *openmenu;
	IBOutlet NSMenu *editmenu;
	IBOutlet NSMenuItem *copyitem;
	IBOutlet NSMenuItem *pasteitem;
}


-(id)init;

-(void)applicationDidFinishLaunching:(NSNotification *)notification;

-(BOOL)application:(NSApplication *)app openFile:(NSString *)filename;
-(IBAction)openDocument:(id)sender;

-(void)menuNeedsUpdate:(NSMenu *)menu;
-(BOOL)menuHasKeyEquivalent:(NSMenu *)menu forEvent:(NSEvent *)event target:(id *)target action:(SEL *)action;
-(void)buildOpenMenu:(NSMenu *)menu;
-(void)updateDefaultEditorItem;
-(NSString *)defaultEditor;
-(void)setDefaultEditor:(NSString *)app;
-(IBAction)setDefaultEditorFromMenu:(id)sender;
-(void)updateEditMenu:(NSMenu *)menu;

-(void)paste:(id)sender;

-(IBAction)dummy:(id)sender;

-(XeeDirectoryController *)newDirectoryWindow;
-(XeeController *)newClipboardWindow;
-(id)instantiateWindowFromNib:(NSNib *)nib;

-(BOOL)xeeFocus;

@end

@interface XeeApplication:NSApplication
{
}

-(void)sendEvent:(NSEvent *)event;

@end
