#import <Cocoa/Cocoa.h>

@class XeeImage,XeeController;

@interface XeeView:NSOpenGLView
{
	XeeImage *image;
	NSTimer *scrolltimer;

	int width,height;
	int imgwidth,imgheight;
	float zoom;

	bool up,down,left,right;
	int x,y;
}

-(id)initWithFrame:(NSRect)frameRect;
-(void)dealloc;
-(void)drawRect:(NSRect)rect;
-(void)reshape;
-(BOOL)acceptsFirstResponder;
-(BOOL)isOpaque;
-(void)keyDown:(NSEvent *)event;
-(void)keyUp:(NSEvent *)event;
-(void)mouseDown:(NSEvent *)event;
-(void)mouseUp:(NSEvent *)event;
-(void)mouseDragged:(NSEvent *)event;
-(void)resetCursorRects;

-(void)setImage:(XeeImage *)img;
-(void)setImageSize:(NSSize)size;

-(void)startScrolling;
-(void)stopScrolling;
-(void)scroll:(NSTimer *)timer;

-(NSPoint)focus;
-(void)setFocus:(NSPoint)focus;
-(void)clampCoords;

-(BOOL)isFlipped;
-(void)copyGLtoQuartz;

@end
